<?php
  
class EmailQueue extends Module 
{    
  function AddItem($To, $Subject, $Content, $From, $AttachmentFileId = '')
  {
    $Values = array('To' => $To, 
      'Subject' => $Subject, 'Content' => $Content, 'Time' => 'NOW()', 
      'From' => $From);
    if($AttachmentFileId != '') $Values['AttachmentFile'] = $AttachmentFileId;
    $this->Database->insert('EmailQueue', $Values);
  }
 
  function Process()
  {
    $Output = '';
    $DbResult = $this->Database->select('EmailQueue', '*', 'Archive=0');
    while($DbRow = $DbResult->fetch_assoc())
    {      
      $Mail = new Mail();
      $Mail->AddToCombined($DbRow['To']);
      $Mail->Subject = $DbRow['Subject'];
      $Mail->From = $DbRow['From'];
      $Mail->AddBody(strip_tags($DbRow['Content']), 'text/plain');
      $Mail->AddBody($DbRow['Content'], 'text/html');
      if($DbRow['AttachmentFile'] != '')
      {
        $DbResult2 = $this->Database->select('File', '*', 'Id='.$DbRow['AttachmentFile']);
        while($File = $DbResult2->fetch_assoc())
          $Mail->AttachFile($this->Config['Web']['FileRootFolder'].$File['DrivePath'], $File['MimeType']);
      }
      $Mail->Send();
      $this->Database->update('EmailQueue', 'Id='.$DbRow['Id'], array('Archive' => 1));
      $this->ModuleManager->Modules['Log']->NewRecord('System', 'SendEmail', $DbRow['Id']);
      $Output .= 'To: '.$DbRow['To'].'  Subject: '.$DbRow['Subject'].'<br />';
    }    
    return($Output);
  }
}
  
?>